#ifndef _LED_H_
#define _LED_H_

#include "stm32f0xx_hal.h"
#include <stdbool.h>
#include <string.h>

typedef enum {
    LED_STATUS = 0,
    LED_CAN,
    LED_ERROR,
} led_name_t;

void led_init(void);
void led_blink(led_name_t led, uint16_t period);
void led_stop(led_name_t led);
void led_blink_once(led_name_t led, uint16_t period);
void led_update(led_name_t led);
void led_update_all(void);
void led_set(led_name_t led, bool value);
void led_toggle(led_name_t led);
bool led_set_brightness(uint8_t brightness);

bool gpio_set_led_brightness(uint8_t brightness);
bool gpio_set_led(led_name_t led, bool value);
bool gpio_toggle_led(led_name_t led);

#endif /* _LED_H_ */
